#include <iostream>
#include "MyRTTI.h"

class CCar
{
	MyDeclareRTTI;

public:
	void Show() {	std::cout << "This is Car." << std::endl;  }
};

class CAirplane
{
	MyDeclareRTTI;

public:
	void Show() {  std::cout << "This is Airplane." << std::endl;  }
};

//޸  ý...  ڴ.
class CTaxi : CCar, CAirplane
{
	MyDeclareRTTI;

public:
	void Show() {	std::cout << "This is Taxi." << std::endl;  }
};

class CCallTaxi : CTaxi
{
	MyDeclareRTTI;
public: 
	void Show()	{	std::cout << "This is CallTaxi." << std::endl;  }
};

class CBus : CCar
{
	MyDeclareRTTI;
public:
	char* m_str;
	void SetText(char * szText) 
	{
		m_str = szText;
	}
	void Show() {	
		std::cout << m_str << std::endl;   
	}
};


MyImplementBaseRTTI(CCar);
MyImplementBaseRTTI(CAirplane);
MyImplementRTTI(CCallTaxi, CTaxi);
MyImplementRTTI2(CTaxi, CCar, CAirplane);
//const MyRTTI CTaxi::m_rtti ("CTaxi", 2, &CCar::m_rtti, &CAirplane::m_rtti);
MyImplementRTTI(CBus, CCar);

void main()
{
	CCar  car;
	CTaxi taxi;
	CAirplane airplane;
	CBus  bus;

	bus.SetText("abcdabcd");
	bus.Show();

	std::cout << car.GetRTTI().GetClassName() << "   *****   "  << airplane.GetRTTI().GetClassName() << std::endl;

	if (MyDerivedFrom(CCar, taxi))
		std::cout << "taxi Derived from CCar" << std::endl;
	if (MyDerivedFrom(CAirplane, taxi))
		std::cout << "taxi Derived from CAirplane" << std::endl;
	if (MyDerivedFrom(CAirplane, bus) == false)
		std::cout << "bus does not Derived from CAirplane" << std::endl;
}	